﻿using System;
using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using NerdWare.Crm2011VsTools.Core.Crm;

namespace NerdWare.Crm2011VsTools.Tests.Core.Crm
{
    [TestClass]
    public class IDiscoverCrmTest
    {
        private readonly Type _iDiscoverCrm = typeof (IDiscoverCrm);

        #region Specification Tests
        /// <summary>
        /// Determines whether [is A public interface].
        /// </summary>
        [TestMethod]
        public void IsAPublicInterface()
        {
            Assert.IsTrue(_iDiscoverCrm.IsInterface, "IDiscoverCrm need to be an Interface!");
            Assert.IsTrue(_iDiscoverCrm.IsPublic, "IDiscoverCrm need to be public!");
        }

        /// <summary>
        /// Has 5 Methods.
        /// </summary>
        [TestMethod]
        public void Has5Methods()
        {
            Assert.AreEqual(5, _iDiscoverCrm.GetMethods().Length, "IDiscoverCrm doe not have the expected amount of Methods!");
        }

        /// <summary>
        /// Determines whether [has method discover].
        /// </summary>
        [TestMethod]
        public void HasMethodDiscover()
        {
            MethodInfo method = _iDiscoverCrm.GetMethod("Discover");

            Assert.IsNotNull(method, "Discover Method does not exist!");
            Assert.AreEqual(method.MemberType, MemberTypes.Method, "Discover is not a Method!");
            Assert.AreEqual(method.ReturnType, typeof (void), "Discover return type is not void!");
        }
        #endregion
    }
}
